angular.module('app.motivationalPage', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.motivationalPage', {
    url: '/motivationalPage/',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'app/calendar/motivational_page/motivationalPage.html',
        controller: 'MotivationalPageCtrl'
      }
    },
    params: {
      message: undefined,
      challengeID: undefined
    }
  });
})

.controller('MotivationalPageCtrl', function($scope, $stateParams, $cordovaGoogleAnalytics, $ionicHistory, $ionicNativeTransitions) {
  console.log("Inside MotivationalPageCtrl");

  try {
    $cordovaGoogleAnalytics.trackView('Motivational Page');
  } catch (e) {
    console.error("Error tracking Google cordovaGoogleAnalytics on motivational page");
  }

  $scope.message = $stateParams.message;

  $scope.goToCalendar = function() {
    if ($scope.transitioning) return;

    $scope.transitioning = true;

    $ionicHistory.nextViewOptions({
      disableBack: true
    });

    $ionicNativeTransitions.stateGo('app.calendar', 
      {challengeID: $stateParams.challengeID}, 
      { type: 'slide', direction: 'right'}
    );
  }

})