angular.module('app.forgotpwd', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.forgotpwd', {
    url: '/forgotpwd',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'app/forgotpwd/forgotpwd.html',
        controller: 'ForgotPwdCtrl'
      }
    }
  });
})

.controller('ForgotPwdCtrl', function($scope, $rootScope, $state, $ionicModal, $ionicPopup, $ionicLoading, $timeout, $cordovaGoogleAnalytics) {
  console.log("Inside ForgotPwdCtrl");
  try {
    $cordovaGoogleAnalytics.trackView('Forgot Password');
  } catch (e) {
    console.error("Error tracking Google cordovaGoogleAnalytics Forgot Password");
  }

  $scope.user = {};
  $scope.error = {};
  $scope.error.message = "";
  $scope.state = {
    success: false
  };

   // Create the login modal that we will use later
  $ionicModal.fromTemplateUrl('app/forgotpwd/forgotpwd.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });

  // Triggered in the login modal to close it
  $scope.closeForgot = function() {
    $scope.modal.hide();
    $state.go('app.login');
  };

  // Open the login modal
  $scope.reset = function() {
    $scope.modal.show();
  };

  $scope.passwordReset = function(){
    console.log('EMAIL input is: ', $scope.user.email);
    
    Parse.User.requestPasswordReset($scope.user.email, {
      success: function() {
        console.log('Password reset email sent');
        $scope.state.success = true;
        $scope.$apply();
        var popUp = $ionicPopup.show({
          title: 'Please check your email',
          subTitle : 'An email has been sent with instructions on how to reset your password',
          buttons: 
          [{ 
            text: 'Okay',
            type: 'button-calm',
            onTap: function(e){
              $scope.closeForgot();
              $state.go('app.login');
            }
          }]
        });
      },
      error: function(error) {
        if(error.code === 205){
            $scope.error.message = ('The email you entered does not have a registered account.');
        }
        else{
          $scope.error.message = error.message;
        }
      }
    });
  }

  $scope.backToLogin = function (){
    console.log('Back to Login Clicked');
    $scope.closeForgot();
    $state.go('app.login');
  }

})