angular.module('app.fitnessAdvanced', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.fitnessAdvanced', {
    url: '/fitness/advanced',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'app/preview/fitness/advanced/advanced.html',
        controller: 'FitnessAdvancedCtrl'
      }
    }
  });
})

.controller('FitnessAdvancedCtrl', function($scope, $rootScope, $state, $ionicModal, $timeout, $cordovaGoogleAnalytics, $sce) {
  console.log("Inside FitnessAdvancedCtrl");

  try {
    $cordovaGoogleAnalytics.trackView('Samples - Advanced Workouts');
  } catch (e) {
    console.error("Error tracking Google cordovaGoogleAnalytics Fitness view");
  }

  $scope.modalParams = {};

  var fireNativeTransition = function(direction, cb) {
    if ($scope.transitionTimeout) return;
    $scope.transitionTimeout = $timeout(function(){
      window.plugins.nativepagetransitions.executePendingTransition();
      $scope.transitionTimeout = null
      if (cb) { cb(); }
    }, 300);
    window.plugins.nativepagetransitions.slide({direction: direction});
  }

  var openWorkoutModal = function() {
    $ionicModal.fromTemplateUrl('app/preview/fitness/workoutDetailsModal.html', {
      scope: $scope,
      animation: 'none'
    }).then(function(modal) {
      $scope.modal = modal;
      fireNativeTransition("left");
      $scope.modal.show();
    });
  }

  $scope.closeModal = function() {
    fireNativeTransition("right", function() { 
      $scope.modalParams = {};
    });
    $scope.modal.remove();
  };

  $scope.jumpRopeClick = function() {
    $scope.modalParams.title = 'JUMP ROPE';
    $scope.modalParams.description = 'Real jump roping. Faux jump roping. It don’t matter. Just make sure if you’re faux jump roping that you jump like you’re actually trying to make it over a rope. Feel free to get fancy with crossovers and any other rope tricks you have up your sleeve.';
    $scope.modalParams.image = 'img/jump-rope.jpg';

    openWorkoutModal();
  }

  $scope.boxTapsClick = function() {
    $scope.modalParams.title = 'BOX TAPS';
    $scope.modalParams.description = 'Stand in front of an object and lightly tap it with one foot. Jump, switch feet, and tap the object with the opposite foot, landing through the ball of your standing foot with a soft knee. Keep doing this continuously. One tap on each foot is one rep. If you’re up for the challenge, do these on a chair. The lower the object you tap, the easier the exercise — but it’s an intense exercise no matter what. PS: We love to play a game of “I spy something I can do taps on!” when out on jogs and walks.';
    $scope.modalParams.image = 'img/box-taps.jpg';

    openWorkoutModal();
  }

  $scope.weightedSquatJumpsClick = function() {
    $scope.modalParams.title = 'SQUAT JUMPS';
    $scope.modalParams.description = 'Do a standard squat holding 5-8lb hand weights (if you have them). Blast up into a jump and then land through the balls of your feet back into a squat. Legs shoulder-width apart, tummy engaged. Squat less deeply if that’s better for your body.';
    $scope.modalParams.image = 'img/squat-jumps.jpg';

    openWorkoutModal();
  }

  $scope.benchHopsClick = function() {
    $scope.modalParams.title = 'BENCH HOPS';
    $scope.modalParams.description = 'Freaking heart this exercise so hard. Hold your bench by the sides and jump over it. Then jump back to where you came from. Each jump counts as one rep. You can mime this exercise with a chair if you don’t have a bench. Just hold the chair and pretend you’re hopping over a bench. Works just as well.';
    $scope.modalParams.image = 'img/bench-hops.jpg';

    openWorkoutModal();
  }

  $scope.pressJacksClick = function() {
    $scope.modalParams.title = 'PRESS JACKS';
    $scope.modalParams.description = 'Start with your arms raised to your shoulders. Every time you jump out, press up. Every time you jump in, bring your arms back to the starting position. Voila!';
    $scope.modalParams.image = 'img/press-jacks.jpg';

    openWorkoutModal();
  }

  $scope.plankWalkUpsClick = function() {
    $scope.modalParams.title = 'PLANK WALKUPS';
    $scope.modalParams.description = 'Start in an elbow plank. Walk up one arm at a time until you’re in a straight-arm plank. Walk down one arm at a time until you’re back in an elbow plank. This exercise works each arm differently. When we say “each side” we mean do one set starting with your right arm first and another set starting with your left arm first.';
    $scope.modalParams.image = 'img/plank-walkups.jpg';

    openWorkoutModal();
  }

  $scope.lungeSkipsClick = function() {
    $scope.modalParams.title = 'LUNGE SKIPS';
    $scope.modalParams.description = 'Start standing with your legs shoulder-width apart. Step back into a lunge with your right leg. Make sure your front knee doesn’t come past your toes. Your front leg should be a 90 degree angle whenever you do lunges. As you bring your right knee up, hop on your left leg and then return your right leg to the lunge position. If you can’t get the hop at first, don’t stress. Just lift the knee.';
    $scope.modalParams.image = 'img/lunge-skip.jpg';

    openWorkoutModal();
  }

});