angular.module('app.fitnessBeginner', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.fitnessBeginner', {
    url: '/fitness/beginner',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'app/preview/fitness/beginner/beginner.html',
        controller: 'FitnessBeginnerCtrl'
      }
    }
  });
})

.controller('FitnessBeginnerCtrl', function($scope, $rootScope, $state, $ionicModal, $ionicLoading, $timeout, $cordovaGoogleAnalytics) {
  console.log("Inside FitnessBeginnerCtrl");

  try {
    $cordovaGoogleAnalytics.trackView('Samples - Beginner Workouts');
  } catch (e) {
    console.error("Error tracking Google cordovaGoogleAnalytics Fitness view");
  }

  $scope.modalParams = {};

  var fireNativeTransition = function(direction, cb) {
    if ($scope.transitionTimeout) return;
    $scope.transitionTimeout = $timeout(function(){
      window.plugins.nativepagetransitions.executePendingTransition();
      $scope.transitionTimeout = null
      if (cb) { cb(); }
    }, 300);
    window.plugins.nativepagetransitions.slide({direction: direction});
  }

  var openWorkoutModal = function() {
    $ionicModal.fromTemplateUrl('app/preview/fitness/workoutDetailsModal.html', {
      scope: $scope,
      animation: 'none'
    }).then(function(modal) {
      $scope.modal = modal;
      fireNativeTransition("left");
      $scope.modal.show();
    });
  }

  $scope.closeModal = function() {
    fireNativeTransition("right", function() { 
      $scope.modalParams = {}; 
    });
    $scope.modal.remove();
  };

  $scope.plankClick = function() {
    $scope.modalParams.title = 'PLANK';
    $scope.modalParams.description = 'Start in the top of a pushup then lower to your forearms. Now, imitate a plank of wood by tilting your pelvis forward and pulling your belly button toward your spine. Don’t let your neck droop. Squeeze your abs as tight as you can throughout the whole plank so your back doesn’t arch. This is what gets you results and what keeps your back and shoulders safe. Breathe. You’re planking! #applause';
    $scope.modalParams.image = 'img/plank.jpg';

    openWorkoutModal();
  }

  $scope.pushUpsClick = function() {
    $scope.modalParams.title = 'PUSHUPS';
    $scope.modalParams.description = 'First off, you can totally do these with your knees on the ground until you get strong enough to go full push up. Proper form is what’s most important. Just like the plank, you’re holding your abs in and making your body one straight line with no arch in the lower back or droop in the neck. (After all, the push up is simply a moving plank.) Breathe in as you slowwwly lower down close to the floor and breathe out as you slowwwly push up. Breathing is the secret to exercise. Your body can do way more when you feed it air. Learning how to breathe right will rock your Fit Girl exercise world.';
    $scope.modalParams.image = 'img/pushup.jpg';

    openWorkoutModal();
  }

  $scope.tricepDipsClick = function() {
    $scope.modalParams.title = 'TRICEP DIPS';
    $scope.modalParams.description = 'Sit on the edge of a chair. Slide your booty off the end and hold yourself up, keeping a teeny bend in your elbows. Tummy engaged. (Yes, proper form makes everything a secret core exercise.) Breathe in as you dip down until your arms almost make 90 degree angles. Breathe out as you push back up, still keeping that tiny bend in the elbows when you reach the top. Make sure your shoulders stay down and stay pointed to the wall behind you. #sexyarms';
    $scope.modalParams.image = 'img/tricep-dip.jpg';

    openWorkoutModal();
  }

  $scope.reverseCrunchesClick = function() {
    $scope.modalParams.title = 'REVERSE CRUNCHES';
    $scope.modalParams.description = 'Start lying on your back with your arms out to the sides and your legs together in a perfect 90 degree position. Pull your core in tight. Use your lower abs to raise your hips off the ground toward your head, keeping your legs at a 90 degree angle. Return to starting position. These are super amazing for your lower tummy.';
    $scope.modalParams.image = 'img/reverse-crunch.jpg';

    openWorkoutModal();
  }

  $scope.sumoSquatsClick = function() {
    $scope.modalParams.title = 'SUMO SQUATS';
    $scope.modalParams.description = 'Sumo squats are super fab for your inner thighs, legs, and booty. Stand with your legs wider than shoulder-width and your feet turned out about 45 degrees. Slowly squat down low, tummy engaged, and slowly come back up. Breathe. To give yourself a calf-toning, cardio-blasting bonus: Add a jump! “How do I do that?!” Instead of coming up slowly from your squat to standing, spring up into a jump then land softly through the balls of your feet back into a squated position. Then spring up into a jump again until you are done with your whole set. Start with the basic sumo and see how it goes, then build in the jump if you can!';
    $scope.modalParams.image = 'img/sumo-squat.jpg';

    openWorkoutModal();
  }
});