angular.module('app.fitnessIntermediate', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.fitnessIntermediate', {
    url: '/fitness/intermediate',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'app/preview/fitness/intermediate/intermediate.html',
        controller: 'FitnessIntermediateCtrl'
      }
    }
  });
})

.controller('FitnessIntermediateCtrl', function($scope, $rootScope, $state, $ionicModal, $ionicLoading, $timeout, $cordovaGoogleAnalytics) {
  console.log("Inside FitnessIntermediateCtrl");

  try {
    $cordovaGoogleAnalytics.trackView('Samples - Intermediate Workouts');
  } catch (e) {
    console.error("Error tracking Google cordovaGoogleAnalytics Fitness view");
  }

  $scope.modalParams = {};

  var fireNativeTransition = function(direction, cb) {
    if ($scope.transitionTimeout) return;
    $scope.transitionTimeout = $timeout(function(){
      window.plugins.nativepagetransitions.executePendingTransition();
      $scope.transitionTimeout = null
      if (cb) { cb(); }
    }, 300);
    window.plugins.nativepagetransitions.slide({direction: direction});
  }

  var openWorkoutModal = function() {
    $ionicModal.fromTemplateUrl('app/preview/fitness/workoutDetailsModal.html', {
      scope: $scope,
      animation: 'none'
    }).then(function(modal) {
      $scope.modal = modal;
      fireNativeTransition("left");
      $scope.modal.show();
    });
  }

  $scope.closeModal = function() {
    fireNativeTransition("right", function() { 
      $scope.modalParams = {}; 
    });
    $scope.modal.remove();
  };

  $scope.toeTouchCrunchesClick = function() {
    $scope.modalParams.title = 'TOE TOUCH CRUNCHES';
    $scope.modalParams.description = 'Lay on your back with your core pulled in tight and arms extended straight up. Don’t let your ribs flare out. Use your core to lift your upper back off the ground as you reach for your toes. (You’ll get closer to them the stronger you get!) Keep your core engaged as you lower down.';
    $scope.modalParams.image = 'img/toe-touch-crunches.jpg';

    openWorkoutModal();
  }

  $scope.sidePlankDipsClick = function() {
    $scope.modalParams.title = 'SIDE PLANK DIPS';
    $scope.modalParams.description = 'Start in a side plank. Core and ribs pulled in tight. Lower your hips down until your bottom hip lightly brushes the floor. Return to starting position.';
    $scope.modalParams.image = 'img/side-plank-dips.jpg';

    openWorkoutModal();
  }

  $scope.lungeTwistsClick = function() {
    $scope.modalParams.title = 'LUNGE TWISTS';
    $scope.modalParams.description = 'Start standing with your legs shoulder-width apart holding one hand weight with two hands. Step back into a lunge with your right leg as you raise your arms to chest level with a tiny bend in your elbows. Make sure your front knee doesn’t come past your toes. Your front leg should be a 90 degree angle whenever you do lunges. Keeping your arms almost straight, twist your torso to the left. Twist back to center then push off your right leg to return to standing. Total body domination.';
    $scope.modalParams.image = 'img/lunge-twists.jpg';

    openWorkoutModal();
  }

  $scope.burpeesClick = function() {
    $scope.modalParams.title = 'BURPEES';
    $scope.modalParams.description = 'We love burpees! They make us feel so empowered. We have no idea why everyone picks on them. Poor little burpees! To to a burpee: Stand with your feet shoulder-width apart. Crouch down. Jump out to the top of a push up. (Make sure your abs are pulled in and your back isn’t arched.) Jump back in. Stand up and jump into the air. Land with bent knees through the balls of your feet and go back down into a crouch for your next burpee. To make them easier, step back into a plank instead of jumping back. To make them harder, add a push up after you jump into the plank.';
    $scope.modalParams.image = 'img/burpees.jpg';

    openWorkoutModal();
  }

  $scope.plankLiftsClick = function() {
    $scope.modalParams.title = 'PLANK LIFTS';
    $scope.modalParams.description = 'How strong is your core? You’re about to find out. Start in a high plank with your feet shoulder-width apart. Carefully raise your opposite arm and leg while pulling your tummy in crazy tight to keep your balance. Repeat on the opposite side.';
    $scope.modalParams.image = 'img/plank-lifts.jpg';

    openWorkoutModal();
  }

  $scope.bicycleCrunchesClick = function() {
    $scope.modalParams.title = 'BICYCLE CRUNCHES';
    $scope.modalParams.description = 'This is one of the most effective core exercises, so get ready to do a lot of them. Start lying down on the ground and then crunch up with your elbow reaching toward your opposite knee and the other leg extended at a 45 degree angle. Now switch sides. Keep alternating as you go. Make sure your hands are to the sides of your ears not behind your head so that you’re only using your core to lift and not straining your neck.';
    $scope.modalParams.image = 'img/bicycle-crunches.jpg';

    openWorkoutModal();
  }

  $scope.squatJumpsClick = function() {
    $scope.modalParams.title = 'SQUAT JUMPS';
    $scope.modalParams.description = 'Why are squat jumps in an ab workout? Because squat jumps are an amazing ab workout too. Squat down, blast up into a jump and then land through the balls of your feet back into a squat. Legs shoulder-width apart, tummy engaged. Squat less deeply if that’s better for your body.';
    $scope.modalParams.image = 'img/squat-jumps.jpg';

    openWorkoutModal();
  }
});