angular.module('app.preview', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.preview', {
    url: '/preview',
    views: {
      'menuContent': {
        templateUrl: 'app/preview/preview.html',
        controller: 'PreviewCtrl'
      }
    }
  });
})

.controller('PreviewCtrl', function($scope, $rootScope, $state, $ionicModal, $ionicLoading, $timeout, $cordovaGoogleAnalytics) {
  console.log("Inside PreviewCtrl");

  try {
    $cordovaGoogleAnalytics.trackView('Preview');
  } catch (e) {
    console.error("Error tracking Google cordovaGoogleAnalytics Preview view");
  }

  $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
    viewData.enableBack = true;
  });

  $scope.goToIntro = function () {
    console.log('Go To Intro CLICKED!');
    $state.go('app.intro');
  }

  $scope.goToRecipes = function () {
    console.log('Go To Recipes CLICKED!');
    $state.go('app.recipes');
  }

  $scope.goToFitness = function () {
    console.log('Go To Workout/Fitness CLICKED!');
    $state.go('app.fitness');
  }

  $scope.goToConclusion = function () {
    console.log('Go To Conclusion CLICKED!');
    $state.go('app.conclusion');
  }
})