angular.module('app.recipes', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.recipes', {
    url: '/recipes',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'app/preview/recipes/recipes.html',
        controller: 'RecipesCtrl'
      }
    }
  });
})

.controller('RecipesCtrl', function($scope, $rootScope, $state, $ionicModal, $ionicLoading, $timeout, $cordovaGoogleAnalytics) {
  console.log("Inside RecipesCtrl");

  try {
    $cordovaGoogleAnalytics.trackView('Samples - Recipes');
  } catch (e) {
    console.error("Error tracking Google cordovaGoogleAnalytics Recipes view");
  }

  $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
    viewData.enableBack = true;
  });

  var fireNativeTransition = function(direction, cb) {
    if ($scope.transitionTimeout) return;
    $scope.transitionTimeout = $timeout(function(){
      window.plugins.nativepagetransitions.executePendingTransition();
      $scope.transitionTimeout = null
      if (cb) { cb(); }
    }, 300);
    window.plugins.nativepagetransitions.slide({direction: direction});
  }

  $scope.recipeClick = function (recipe) {
    try {
      $cordovaGoogleAnalytics.trackView('Sample - Recipes - ' + recipe);
    } catch (e) {
      console.error("Error tracking Google cordovaGoogleAnalytics Preview - Recipes - " + recipe);
    }
    
    angular.extend($scope, {
      cinnafitbun: false,
      fitgirlcobb: false,
      fitnanasplit: false,
      pitapizzaparty: false,
      fitgirlparm: false,
      stupideasymac: false,
      proteinlovebites: false
    });
    $scope[recipe] = true;

    $ionicModal.fromTemplateUrl('app/preview/recipes/modal-recipes.html', {
      scope: $scope,
      animation: 'none'
    }).then(function(modal) {
      $scope.modal = modal;
      fireNativeTransition("left", function() {
        $scope.modal.show();
      });
    });

    $scope.closeModal = function() {
      fireNativeTransition("right", function() {
        // set the boolean back to false so new modals can load
        $scope[recipe] = false;
      });
      $scope.modal.remove();
    }
  }

})