angular.module('app.register', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.register', {
    url: '/register',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'app/register/register.html',
        controller: 'RegisterCtrl'
      }
    }
  });
})

.controller('RegisterCtrl', function($scope, $rootScope, $state, $ionicModal, $ionicLoading, $ionicPopup, $timeout, ngFB, AddWorkoutsSrv, FaceBookConnectSrv, $cordovaGoogleAnalytics, PushSrv) {
  console.log("Inside RegisterCtrl");

  try {
    $cordovaGoogleAnalytics.trackView('Register');
  } catch (e) {
    console.error("Error tracking Google cordovaGoogleAnalytics Register");
  }

  $scope.backButton = $rootScope.$ionicGoBack

  $scope.user = {};
  $scope.error = {};
  $scope.error.message = "";

  $scope.saveToParse = function () {
    
    var user = new Parse.User();

    // Both Parse username and email MUST be set to the email address!!
    // Parse username must be the email for user to login with that
    // Parse email must be the email in order to use Parse email verification
    // Also want to keep Parse username and email the same for any subsequent changes

    user.set("firstName", $scope.user.firstName);
    user.set("lastName", $scope.user.lastName);
    user.set("username", $scope.user.username);
    user.set("email", $scope.user.username);
    user.set("password", $scope.user.password);
    user.set("agree", $scope.user.agree);

    console.log("First Name: ", $scope.user.firstName);
    console.log("Last Name: ", $scope.user.lastName);
    console.log("Email: ", $scope.user.username);
    console.log("Agreed: ", $scope.user.agree);

    $scope.loading = $ionicLoading.show({
      content: 'Sending',
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      showDelay: 0
    });

    user.signUp(null, {
      success: function(user) {
        $ionicLoading.hide();
        $rootScope.user = user;
        //NOTE: User object must be accessed through 'attributes'
        console.log('Register --> Username = ' + user.attributes.username);
        $rootScope.isLoggedIn = true;
        PushSrv.register();
        $scope.promise();
      },
      error: function(user, error) {
        $ionicLoading.hide();
        if (error.code === 125) {
            $scope.error.message = 'Please specify a valid email address';
        } else if (error.code === 202) {
            $scope.error.message = 'The email address is already registered';
        } else {
            $scope.error.message = error.message;
        }
        //$scope.$apply();
      }
    });
  }

  $scope.promise = function () {
      $ionicModal.fromTemplateUrl('app/register/modal-promise.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.promiseModal = modal;
        $scope.showPromiseModal();
      });
      
      $scope.showPromiseModal = function () {
        $scope.promiseModal.show();
      }

      $scope.hidePromiseModal = function () {
        var myPopup = $ionicPopup.show({
          title: 'VERIFY YOUR EMAIL',
          subTitle: "Hey Fit Girl, don't forget to verify your email address!",
          buttons: [
            {
              text: '<b>Okay</b>',
              type: 'button-calm',
              onTap: function(e) {
                $scope.promiseModal.hide();
                $state.go('app.home');         
              }
            }
          ]
        })
      }
  }

  $scope.goBackToLoginFromRegister = function() {
    try {
      $cordovaGoogleAnalytics.trackEvent('Register' , 'User Clicked Back to Login');
    } catch (e) {
      console.error("Error tracking Google cordovaGoogleAnalytics Back to Login");
    }
    $state.go('app.login');
  }

  $scope.backToWelcome = function() {
    try {
      $cordovaGoogleAnalytics.trackEvent('Register' , 'User Clicked Back to Welcome');
    } catch (e) {
      console.error("Error tracking Google cordovaGoogleAnalytics Back to Welcome");
    }
    $state.go('app.welcome');
  }

  $scope.register = function () {
    try {
      $cordovaGoogleAnalytics.trackEvent('Register' , 'User Clicked Register');
    } catch (e) {
      console.error("Error tracking Google cordovaGoogleAnalytics Register");
    }

    if($scope.user.password == $scope.user.confirmPassword){
      if ($scope.user.agree === true) {
        $scope.saveToParse();
      }
      else {
        $ionicPopup.alert({
          title: "TERMS AND CONDITIONS",
          subTitle: "You must agree to the terms and conditions before becoming a FitGirl.",
          scope: $scope,
          buttons: [
            {
              text: '<b>Okay</b>',
              type: 'button-calm',
            }
          ]
        });
      }
    }
    else{
      $scope.error.message = 'Passwords do not match. Please try again. You can use a combination of letters, numbers, and symbols';
    }
  }

  $scope.fbLogin = function () {
    try {
      $cordovaGoogleAnalytics.trackEvent('Register' , 'User Clicked Connect with Facebook');
    } catch (e) {
      console.error("Error tracking Google cordovaGoogleAnalytics FB Connect");
    }
    ngFB.login({scope: 'email,public_profile'}).then(
      function (response) {
        if (response.status === 'connected') {
          FaceBookConnectSrv.getFBUserDetails();

          $ionicLoading.show({
            template: '<h2>Registering...</h2>',
            duration: 3000,
            noBackdrop: true,
            hideOnStateChange: true
          });
          console.log('Facebook login succeeded');
        } else {
            $ionicPopup.alert({
              title: "Something went wrong!",
              subTitle: "We could not connect to your facebook.  Please try again!",
              scope: $scope,
              buttons: [
                {
                  text: '<b>Okay</b>',
                  type: 'button-calm',
                }
              ]
            });
            try {
              $cordovaGoogleAnalytics.trackEvent('Register', 'Register with Facebook Failed', 100);
            } catch (e) {
              console.error("Error tracking Google cordovaGoogleAnalytics Facebook Connect Failed");
            }
        }
    });
  };

})