angular.module('app.welcome', [])

//Config block that contains the state declaration
.config(function($stateProvider) {  
  $stateProvider
    .state('app.welcome', {
      url: '/welcome',
      nativeTransitions: {
        "type": "slide",
        "direction": "right"
      },
      views: {
        'menuContent': {
          templateUrl: 'app/welcome/welcome.html',
          controller: 'WelcomeCtrl'
        }
      }
  });
})

.controller('WelcomeCtrl', function($scope, $rootScope, $state, $ionicModal, 
  $ionicLoading, $timeout, $ionicPopup, $cordovaGoogleAnalytics, ngFB, FaceBookConnectSrv) {
  console.log("Inside WelcomeCtrl");

  $scope.goToRegister = function () {
    try {
      $cordovaGoogleAnalytics.trackEvent('Welcome', 'User Clicked Sign Up');
    } catch (e) {
      console.error("Error tracking Google cordovaGoogleAnalytics Welcome --> Sign up");
    }
    $state.go('app.register');
  }

  $scope.goToLogin = function () {
    try {
      $cordovaGoogleAnalytics.trackEvent('Welcome', 'User Clicked Sign In');
    } catch (e) {
      console.error("Error tracking Google cordovaGoogleAnalytics Home --> Sign in");
    }
    $state.go('app.login');
  }

  $scope.fbLogin = function () {
    try {
      $cordovaGoogleAnalytics.trackEvent('Welcome', 'User Clicked Connect with Facebook');
    } catch (e) {
      console.error("Error tracking Google cordovaGoogleAnalytics Welcome --> Fb Connect");
    }
    ngFB.login({scope: 'email,public_profile'}).then(
      function (response) {
        if (response.status === 'connected') {
          FaceBookConnectSrv.getFBUserDetails();

          $ionicLoading.show({
            template: '<h2>Connecting...</h2>',
            duration: 3000,
            noBackdrop: true,
            hideOnStateChange: true
          });

          console.log('Facebook login succeeded');
        } else {
            $ionicPopup.alert({
              title: "Something went wrong!",
              subTitle: "We could not connect to your facebook.  Please try again!",
              scope: $scope,
              buttons: [
                {
                  text: '<b>Okay</b>',
                  type: 'button-calm',
                }
              ]
            });
        }
    });
  };

})