// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('app', [
  'ionic',
  'ionic.service.core',
  'ionic-native-transitions',
  'ngCordova',
  'angularMoment',
  'app.controllers',
  'ngOpenFB',
  'app.register',
  'app.profile',
  'app.ebooks',
  'app.preview',
  'app.login',
  'app.home',
  'app.calendar',
  'app.forgotpwd',
  'app.welcome',
  'app.services',
  'app.sessions',
  'app.session',
  'app.workoutDetails',
  'app.conclusion',
  'app.fitness',
  'app.intro',
  'app.recipes',
  'app.motivationalPage',
  'app.fitnessAdvanced',
  'app.fitnessIntermediate',
  'app.fitnessBeginner'
])

.run(function ($ionicPlatform, $rootScope, $state, $cordovaDevice, $cordovaGoogleAnalytics, ngFB, PushSrv, $ionicHistory, $ionicPlatform, $ionicNativeTransitions) {
  $ionicPlatform.ready(function() {
    ngFB.init({appId: '445456282323876'});
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    // if (window.cordova && window.cordova.plugins.Keyboard) {
    //   cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    //   cordova.plugins.Keyboard.disableScroll(true);
    // }

    /* Begin Google Analytics Initialization */
    try {
      setTimeout(function() { 
        //$cordovaGoogleAnalytics.debugMode();
        // $cordovaGoogleAnalytics.setUserId('jedi');
        $cordovaGoogleAnalytics.startTrackerWithId('UA-68385045-3');
      }, 500);
    } catch (e) {
      console.error('Error: $ionicPlatform.ready() $cordovaGoogleAnalytics');
    }
    /* End Google Analytics Intialization */ 
    
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    if (Parse.User.current()) {
      Parse.User.current().fetch().then(function(user) {
        $rootScope.user = user;
        $rootScope.isLoggedIn = true;
        PushSrv.register();
        console.log('user is logged in && going home');
        $state.go('app.home');
      }, function(err) {
        $rootScope.user = false;
        $rootScope.isLoggedIn = false;
      });
    } else {
      $rootScope.isLoggedIn = false;
      console.log('user is NOT logged in && going to welcome');
      $state.go('app.welcome');
    }

    var customBackButton = function() {
      // overrides existing Ionic back button (both software and hardware)
      // if a backView exists, slide right to it and attempt to maintaim stateParams
      // otherwise, slide right to home page
      var backView = $ionicHistory.backView();
      if (backView) {
        $ionicNativeTransitions.stateGo(backView.stateName, backView.stateParams, {type:'slide', direction:'right'});
      } else if (Parse.User.current()) {
        $ionicNativeTransitions.stateGo('app.home', {}, {type: 'slide', direction: 'right'});
      } else {
        $state.go('app.welcome');
      }
    }

    $rootScope.$ionicGoBack = customBackButton;

    $ionicPlatform.registerBackButtonAction(customBackButton, 101);

  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $ionicNativeTransitionsProvider) {
  $stateProvider

  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  });

  Parse.initialize('d909leo7vo7bkd7pqesvo9r73a5hc8wsih7b4xp0', 't388imqv08wq17nekc2xgoisbl37e0735phxlr8p');
  Parse.serverURL = 'https://pg-app-20ee9rb0r660ix57i3hg57pbq60s05.scalabl.cloud';

  // BACK BUTTON coresponds with menu.html
  $ionicConfigProvider.backButton.text('').icon('ion-ios-arrow-back').previousTitleText(false);
  // Prevent swiping back
  $ionicConfigProvider.views.swipeBackEnabled(false);
  // View forward cache, ex home page to calendar
  $ionicConfigProvider.views.forwardCache(true);

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/welcome');

  // configure native transitions
  $ionicNativeTransitionsProvider.setDefaultTransition({
    type: 'slide',
    direction: 'left'
  });
});
