angular.module('app.services', ['ngResource'])

.factory('Session', function ($resource) {
  return $resource('http://localhost:5000/sessions/:sessionId');
})

.factory('FaceBookConnectSrv', function ($rootScope, $state, ngFB, AddWorkoutsSrv, PushSrv) {
  return {
    getFBUserDetails: function () {
      var self = this;
      ngFB.api({
        path: '/me',
        params: { fields: 'id,first_name,last_name,email,birthday' }
      }).then(function (fbUser) {
        console.log(JSON.stringify(fbUser));
        // check if the user has an account thats linked through 'facebookUserId'
        new Parse.Query(Parse.User).equalTo('facebookUserId', fbUser.id).find()
        .then(function(parseUser) {
          if (!parseUser || parseUser.length < 1) {
            // user does not exist, create a parse user for them
            self.fbToParseRegister(fbUser);
          } else {
            // user exists, log them into their counterpart parse account
            self.fbToParseLogin(parseUser, fbUser);
          }
        }, function(err) {
          console.error(JSON.stringify(err));
          alert('Facebook login failed');
        });
      },function (error) {
          alert('Facebook error: ' + error.error_description);
      });
    },

    fbToParseLogin: function (parseUser, fbUser) {
      console.log('fbToParseLogin');
      Parse.User.logIn(fbUser.id, fbUser.id).then(function(user) {
        $rootScope.user = user;
        $rootScope.isLoggedIn = true;
        PushSrv.register();
        $state.go('app.home');
      }, function(err) {
        alert('Facebook login failed');
        consoe.error(err);
      });
    },

    fbToParseRegister: function(fbUser) {
      console.log('fbToParseRegister');
      var newUser = new Parse.User();
      newUser.set('username', fbUser.id);
      newUser.set('facebookUserId', fbUser.id);
      newUser.set('password', fbUser.id);
      if (fbUser.first_name) newUser.set('firstName', fbUser.first_name);
      if (fbUser.last_name) newUser.set('lastName', fbUser.last_name);
      newUser.signUp(null).then(function(user) {
        $rootScope.user = user;
        $rootScope.isLoggedIn = true;
        PushSrv.register();
        $state.go('app.home');
      }, function(err) {
        console.error(JSON.stringify(err));
        alert('Facebook login failed');
      });
    }
  };
})

.factory('AddWorkoutsSrv', function($rootScope, $q) {
  return {
    add28DayWorkout: function() {
      var deferred = $q.defer();
      var dailyWorkouts = []; 
      var newChallenge = {};
      var Challenge = Parse.Object.extend("Challenge");
      new Challenge().set('name', '28 Day Workout')
      .set('startDate', new Date())
      .save().then(function(_challenge) {
        newChallenge = _challenge;
        $rootScope.user.relation("Challenges").add(_challenge);
        $rootScope.user.set('currentChallenge', _challenge);
        return $rootScope.user.save();
      }).then(function(user) {
        // user successfully saved
        continueFunc();
      }, function(err) {
        return deferred.reject(err);
      });

      function continueFunc() {
        var names = [
          "Arms x3",
          "Booty x3",
          "Abs x3",
          "Cardio",
          "BootyCore x3",
          "ArmCore x3",
          "Stroll + Stretch",
          "Arms x3",
          "Booty x3",
          "Abs x3",
          "Cardio",
          "BootyCore x3",
          "ArmCore x3",
          "Stroll + Stretch",
          "Arms x3",
          "Booty x3",
          "Abs x3",
          "Cardio",
          "BootyCore x3",
          "ArmCore x3",
          "Stroll + Stretch",
          "Arms x3",
          "Booty x3",
          "Abs x3",
          "Cardio",
          "BootyCore x3",
          "ArmCore x3",
          "Stroll + Stretch"
        ];

        var ex = [
          [{'exercise':'Push Up','rep':'5'},{'exercise':'Plank','rep':'20s'},{'exercise':'Mt Climber','rep':'10'},{'exercise':'Tricep Dip','rep':'8'},{'exercise':'Squat Press','rep':'10'},{'exercise':'Plank Jack','rep':'10'}],
          [{'exercise':'Bridge','rep':'10'},{'exercise':'Swimmer','rep':'30s'},{'exercise':'Wall Sit','rep':'20s'},{'exercise':'Sumo Squat','rep':'10'},{'exercise':'Burpees','rep':'5'},{'exercise':'Lunge','rep':'10'}],
          [{'exercise':'Rev Crunch','rep':'15'},{'exercise':'Elbow-Knee','rep':'5'},{'exercise':'Russian','rep':'10'},{'exercise':'Crunch','rep':'15'},{'exercise':'Sit-Up','rep':'10'},{'exercise':'Stand Crunch','rep':'10'}],
          [],
          [{'exercise':'Sumo Squats','rep':'10'},{'exercise':'Wall Sit','rep':'20s'},{'exercise':'Rev Crunch','rep':'10'},{'exercise':'Crunch','rep':'10'},{'exercise':'Sit-Up','rep':'10'},{'exercise':'Burpees','rep':'5'}],
          [{'exercise':'Russian','rep':'10'},{'exercise':'Tricep Dips','rep':'8'},{'exercise':'Mt Climber','rep':'15'},{'exercise':'Push Up','rep':'5'},{'exercise':'Squat Press','rep':'10'},{'exercise':'Sit-Up','rep':'10'}],
          [],
          [{'exercise':'Push Up','rep':'6'},{'exercise':'Plank','rep':'30s'},{'exercise':'Mt Climber','rep':'20'},{'exercise':'Tricep Dip','rep':'12'},{'exercise':'Squat Press','rep':'12'},{'exercise':'Plank Jack','rep':'12'}],
          [{'exercise':'Bridge','rep':'12'},{'exercise':'Swimmer','rep':'30s'},{'exercise':'Wall Sit','rep':'30s'},{'exercise':'Sumo Squat','rep':'12'},{'exercise':'Burpees','rep':'8'},{'exercise':'Lunge','rep':'12'}],
          [{'exercise':'Rev Crunch','rep':'20'},{'exercise':'Elbow-Knee','rep':'8'},{'exercise':'Russian','rep':'15'},{'exercise':'Crunch','rep':'20'},{'exercise':'Sit-Up','rep':'15'},{'exercise':'Stand Crunch','rep':'15'}],
          [],
          [{'exercise':'Sumo Squat','rep':'12'},{'exercise':'Wall Sit','rep':'30s'},{'exercise':'Rev Crunch','rep':'15'},{'exercise':'Crunch','rep':'15'},{'exercise':'Sit-Up','rep':'15'},{'exercise':'Burpees','rep':'10'}],
          [{'exercise':'Russian','rep':'15'},{'exercise':'Tricep Dips','rep':'12'},{'exercise':'Mt Climber','rep':'20'},{'exercise':'Push Up','rep':'8'},{'exercise':'Squat Press','rep':'15'},{'exercise':'Sit-Up','rep':'15'}],
          [],
          [{'exercise':'Push Up','rep':'8'},{'exercise':'Plank','rep':'40s'},{'exercise':'Mt Climber','rep':'30'},{'exercise':'Tricep Dips','rep':'15'},{'exercise':'Squat Press','rep':'15'},{'exercise':'Plank Jack','rep':'15'}],
          [{'exercise':'Bridge','rep':'15'},{'exercise':'Swimmer','rep':'30s'},{'exercise':'Wall Sit','rep':'40s'},{'exercise':'Sumo Squat','rep':'15'},{'exercise':'Burpees','rep':'10'},{'exercise':'Lunge','rep':'15'}],
          [{'exercise':'Rev Crunch','rep':'25'},{'exercise':'Elbow-Knee','rep':'12'},{'exercise':'Russian','rep':'20'},{'exercise':'Crunch','rep':'25'},{'exercise':'Sit-Up','rep':'20'},{'exercise':'Stand Crunch','rep':'20'}],
          [],
          [{'exercise':'Sumo Squat','rep':'15'},{'exercise':'Wall Sit','rep':'40s'},{'exercise':'Rev Crunch','rep':'20'},{'exercise':'Crunch','rep':'20'},{'exercise':'Sit-Up','rep':'20'},{'exercise':'Burpees','rep':'12'}],
          [{'exercise':'Russian','rep':'20'},{'exercise':'Tricep Dips','rep':'15'},{'exercise':'Mt Climber','rep':'30'},{'exercise':'Push Up','rep':'10'},{'exercise':'Squat Press','rep':'20'},{'exercise':'Sit-Up','rep':'20'}],
          [],
          [{'exercise':'Push Up','rep':'10'},{'exercise':'Plank','rep':'60s'},{'exercise':'Mt Climber','rep':'40'},{'exercise':'Tricep Dip','rep':'20'},{'exercise':'Squat Press','rep':'20'},{'exercise':'Plank Jack','rep':'20'}],
          [{'exercise':'Bridge','rep':'20'},{'exercise':'Swimmer','rep':'45s'},{'exercise':'Wall Sit','rep':'60s'},{'exercise':'Sumo Squat','rep':'20'},{'exercise':'Burpees','rep':'15'},{'exercise':'Lunge','rep':'20'}],
          [{'exercise':'Rev Crunch','rep':'30'},{'exercise':'Elbow-Knee','rep':'15'},{'exercise':'Russian','rep':'25'},{'exercise':'Crunch','rep':'30'},{'exercise':'Sit-Up','rep':'20'},{'exercise':'Stand Crunch','rep':'20'}],
          [],
          [{'exercise':'Sumo Squat','rep':'20'},{'exercise':'Wall Sit','rep':'60s'},{'exercise':'Rev Crunch','rep':'25'},{'exercise':'Crunch','rep':'25'},{'exercise':'Sit-Up','rep':'20'},{'exercise':'Burpees','rep':'15'}],
          [{'exercise':'Russian','rep':'25'},{'exercise':'Tricep Dips','rep':'20'},{'exercise':'Mt Climber','rep':'40'},{'exercise':'Push Up','rep':'10'},{'exercise':'Squat Press','rep':'20'},{'exercise':'Sit-Up','rep':'20'}],
          []
        ];

        for(x = 0; x < 28; x++){
          var DailyWorkouts = Parse.Object.extend('DailyWorkouts');
          dailyWorkouts.push(
            new DailyWorkouts()
            .set('day', (x + 1))
            .set('name_workout', names[x])
            .set('exercises', ex[x])
          );
        }

        // save ALL created daily work outs in the dayWorkouts array of new Parse Objs
        Parse.Object.saveAll(dailyWorkouts).then(function(_dailyWorkouts) {
          // add ALL newly created daily workouts into the newly created challege relations
          newChallenge.relation('dailyWorkouts').add(_dailyWorkouts);
          return newChallenge.save();
        }).then(function(_newChallenge) {
          return deferred.resolve(_newChallenge);
        }, function(err) {
          return deferred.reject(err);
        });
      }
      
      return deferred.promise;
    }
  };
})

//http://stackoverflow.com/questions/19839743/nested-ng-repeat

.factory('ChallengeSrv', function ($resource) {
  var service = {};

  service.getDailyWorkouts = function () {
    console.log("Getting daily workouts from service"); 

    var Challenge_TwentyEight = {
      Daily1 : {
        day : 1,
        name_workout: "Russian",
        type: "28 Day",
        workout_response: null,
        exercises : {
          pushups : 20,
          situps : 30
        }
      }, Daily2 : {
        day : 1,
        name_workout: "Russian",
        type: "28 Day",
        workout_response: null,
        exercises : {
          pushups : 20,
          situps : 30
        }
      },Daily3 : {
        day : 1,
        name_workout: "Russian",
        type: "28 Day",
        workout_response: null,
        exercises : {
          pushups : 20,
          situps : 30
        }
      },Daily4 : {
        day : 1,
        name_workout: "Russian",
        type: "28 Day",
        workout_response: null,
        exercises : {
          pushups : 20,
          situps : 30
        }
      },Daily5 : {
        day : 1,
        name_workout: "Russian",
        type: "28 Day",
        workout_response: null,
        exercises : {
          pushups : 20,
          situps : 30
        }
      },Daily6 : {
        day : 1,
        name_workout: "Russian",
        type: "28 Day",
        workout_response: null,
        exercises : {
          pushups : 20,
          situps : 30
        }
      },Daily7 : {
        day : 1,
        name_workout: "Russian",
        type: "28 Day",
        workout_response: null,
        exercises : {
          pushups : 20,
          situps : 30
        }
      }
    }
    console.log("The challenge json is " + JSON.stringify(Challenge_TwentyEight));
    return Challenge_TwentyEight;
  }
  return service;
})

.factory('PushSrv', function($rootScope, $ionicPopup) {
  var user = {};
  var push = new Ionic.Push({
    debug: true,
    onNotification: function(notification) {
      console.log('notification received: ', JSON.stringify(notification));
      $ionicPopup.show({
        title: 'A Message From Fit Girls',
        subTitle : notification.text,
        buttons: 
        [{ 
          text: 'Okay!',
          type: 'button-calm',
          onTap: function(e) {
            return true;
          }
        }]
      });
    },
    pluginConfig: {
      ios: {
        alert: true,
        badge: true,
        sound: true
        //clearBadge: defaulted to false
      },
      android: {
        iconColor: "#ff99cc",
        icon: 'notify'
      }
    }
  });
  return {
    register: function() {
      var details = {
        email: $rootScope.user.id + '@' + $rootScope.user.id + '.com',
        password: 'fitgirls-password'
      };
      
      // sign them up, if error with code conlfict_email, then log them in, otherwise it goes straight to login
      Ionic.Auth.signup(details).then(ionicLogin, ionicFailure);

      function ionicLogin() {
        Ionic.Auth.login('basic', { remember: true }, details).then(registerPush, ionicFailure);
      }

      function ionicFailure(err) {
        if (err.errors[0] === 'conflict_email') {
          ionicLogin();
        }
      }

      function registerPush() {
        push.register(function(data) {
          // save the token in the ionic user
          push.saveToken(data.token);
          // update the ionic user object with current logged in parse user
          user = Ionic.User.current();
          user.details.name = $rootScope.user.get('firstName') + ' ' + $rootScope.user.get('lastName');      
          user.save();
        });
      }

    }
  };
})
